<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.7.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Update User</title>
  </head>
  <body>
    <div class="container jumbotron">
      <div class="text-center mb4">
        <h3 style="margin-bottom: 1rem;">Chi tiết User</h3>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">First Name</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-firstname"
            placeholder="Nhập first name..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-lastname"
            placeholder="Nhập last name..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Subject</label>
        </div>
        <div class="col-sm-9">
          <input
            class="form-control"
            type="text"
            id="input-subject"
            placeholder="Nhập subject..."
          />
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Country</label>
        </div>
        <div class="col-sm-9">
          <select class="form-control" id="select-country">
            <option value="VN">Việt Nam</option>
            <option value="USA">USA</option>
            <option value="AUS">Australia</option>
            <option value="CAN">Canada</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Customer type</label>
        </div>
        <div class="col-sm-9">
          <select class="form-control" id="select-customer-type">
            <option value="Standard">Standard</option>
            <option value="Gold">Gold</option>
            <option value="Premium">Premium</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3">
          <label for="">Register Status</label>
        </div>
        <div class="col-sm-9">
          <select class="form-control" id="select-register-status">
            <option value="New">New</option>
            <option value="Accepted">Accepted</option>
            <option value="Denied">Denied</option>
          </select>
        </div>
      </div>

      <div class="row form-group">
        <div class="col-sm-3"></div>
        <div class="col-sm-9">
          <button class="btn btn-success w-25" id="btn-update-user">
            Update User
          </button>
          <button class="btn btn-success w-25">Hủy bỏ</button>
        </div>
      </div>
    </div>
  </body>
</html>

<script>
  var gEFirstName = $("#input-firstname");
  var gELastName = $("#input-lastname");
  var gESubject = $("#input-subject");
  var gECountry = $("#select-country");
  var gECustomerType = $("#select-customer-type");
  var gERegisterStatus = $("#select-register-status");

  var gId = "";

  $(document).ready(function () {
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      "use strict";
      var vUrlString = window.location.href; //đường đẫn gọi đến trang

      //tạo đối tượng url để truy vấn tham số
      var vUrlObject = new URL(vUrlString);
      //get a parameter
      gId = vUrlObject.searchParams.get("id");

      $.ajax({
        url: "http://203.171.20.210:8080/crud-api/users/" + gId,
        type: "GET",
        dataType: "json", // added data type
        success: function (res) {
          console.log(res);
          loadDataOnForm(res);
        },
        error: function (ajaxContext) {
          alert(ajaxContext.responseText);
        },
      });
    }

    //hàm thực thi khi nút Update User được ấn
    $("#btn-update-user").on("click", function () {
      //B1: get data
      var vDataObj = getFormData();
      //B2: Validate data
      var vCheck = validateFormData(vDataObj);
      if (vCheck) {
        //B3: process update user info
        callAjaxApiUpdateUser(vDataObj);
      }
    });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm tải dữ liệu gửi về lên các trường trên form
    function loadDataOnForm(paramRes) {
      $("#input-firstname").val(paramRes.firstname);
      $("#input-lastname").val(paramRes.lastname);
      $("#input-subject").val(paramRes.subject);
      $("#select-country").val(paramRes.country);
      $("#select-customer-type").val(paramRes.customerType);
      $("#select-register-status").val(paramRes.registerStatus);
    }
  });

  //hàm thu thập dữ liệu
  function getFormData() {
    var vUpdateInfoObj = new Object();

    vUpdateInfoObj.firstname = $.trim(gEFirstName.val());
    vUpdateInfoObj.lastname = $.trim(gELastName.val());
    vUpdateInfoObj.subject = $.trim(gESubject.val());
    vUpdateInfoObj.country = gECountry.val();
    vUpdateInfoObj.customerType = gECustomerType.val();
    vUpdateInfoObj.registerStatus = gERegisterStatus.val();

    return vUpdateInfoObj;
  }

  //hàm kiểm tra dữ liệu
  function validateFormData(paramObjUserData) {
    if (paramObjUserData.firstname == "") {
      alert("Bạn cần điền first name");
      return false;
    }

    if (paramObjUserData.lastname == "") {
      alert("Bạn cần điền last name");
      return false;
    }

    if (paramObjUserData.subject == "") {
      alert("Bạn cần điền subject");
      return false;
    }

    return true;
  }

  //hàm gọi api lấy dữ liệu user dựa vào id
  function callAjaxApiUpdateUser(paramObjUserData) {
    var vJsonString = JSON.stringify(paramObjUserData);
    $.ajax({
      url: "http://203.171.20.210:8080/crud-api/users/" + gId,
      method: "PUT",
      contentType: "application/json;charset=UTF-8",
      data: vJsonString,
      success: function (paramResponse) {
        alert("User ID: " + paramResponse.id + "\nCập nhật thành công");
        window.location.href = "listUsers.html";
      },
      error: function (ajaxtContext) {
        console.log(ajaxtContext);
      },
    });
  }
</script>
